Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trcnam.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trcnam.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trcnam.F90	(revision 2819)
@@ -18,6 +18,6 @@
    !!   trc_nam    :  Read and print options for the passive tracer run (namelist)
    !!----------------------------------------------------------------------
-   USE oce_trc
-   USE trc
+   USE oce_trc           ! shared variables between ocean and passive tracers
+   USE trc               ! passive tracers common variables
    USE trcnam_trp        ! Transport namelist
    USE trcnam_lobster    ! LOBSTER namelist
@@ -26,5 +26,7 @@
    USE trcnam_c14b       ! C14 SMS namelist
    USE trcnam_my_trc     ! MY_TRC SMS namelist
+   USE trdmod_oce       
    USE trdmod_trc_oce
+   USE iom               ! I/O manager
 
    IMPLICIT NONE
@@ -53,25 +55,16 @@
       !!                ( (LOBSTER, PISCES, CFC, MY_TRC )
       !!---------------------------------------------------------------------
-      INTEGER ::  jn
-
+      INTEGER ::  jn, ierr
       ! Definition of a tracer as a structure
-      TYPE PTRACER
-         CHARACTER(len = 20)  :: clsname  !: short name
-         CHARACTER(len = 80 ) :: cllname  !: long name
-         CHARACTER(len = 20 ) :: clunit   !: unit
-         LOGICAL              :: llinit   !: read in a file or not
-         LOGICAL              :: llsave   !: save the tracer or not
-      END TYPE PTRACER
-
-      TYPE(PTRACER) , DIMENSION(jptra) :: sn_tracer
-
+      TYPE(PTRACER), DIMENSION(jptra) :: sn_tracer  ! type of tracer for saving if not key_iomput
       !!
-      NAMELIST/namtrc/    nn_dttrc, nn_writetrc, ln_rsttr, nn_rsttr, &
-                          cn_trcrst_in, cn_trcrst_out, sn_tracer
+      NAMELIST/namtrc/ nn_dttrc, nn_writetrc, ln_rsttr, nn_rsttr, &
+         &             cn_trcrst_in, cn_trcrst_out, sn_tracer, ln_trcdta
 #if defined key_trdmld_trc  || defined key_trdtrc
       NAMELIST/namtrc_trd/ nn_trd_trc, nn_ctls_trc, rn_ucf_trc, &
-                         ln_trdmld_trc_restart, ln_trdmld_trc_instant, &
-                         cn_trdrst_trc_in, cn_trdrst_trc_out, ln_trdtrc
+         &                ln_trdmld_trc_restart, ln_trdmld_trc_instant, &
+         &                cn_trdrst_trc_in, cn_trdrst_trc_out, ln_trdtrc
 #endif
+      NAMELIST/namtrc_dia/ ln_diatrc, ln_diabio, nn_writedia, nn_writebio
 
       !!---------------------------------------------------------------------
@@ -84,17 +77,20 @@
       ! Namelist nattrc (files)
       ! ----------------------------------------------
-      nn_dttrc    = 1                 ! default values
-      nn_writetrc = 10      
-      ln_rsttr    = .FALSE.
-      nn_rsttr    =  0
+      nn_dttrc      = 1                 ! default values
+      nn_writetrc   = 10 
+      ln_rsttr      = .FALSE.
+      nn_rsttr      =  0
       cn_trcrst_in  = 'restart_trc'
       cn_trcrst_out = 'restart_trc'
+      !
       DO jn = 1, jptra
-         WRITE(ctrcnm(jn),'("TR_",I1)'           ) jn
-         WRITE(ctrcnl(jn),'("TRACER NUMBER ",I1)') jn
-         ctrcun(jn) = 'mmole/m3'
-         lutini(jn) = .FALSE. 
-         lutsav(jn) = .TRUE. 
+         WRITE( sn_tracer(jn)%clsname,'("TR_",I1)'           ) jn
+         WRITE( sn_tracer(jn)%cllname,'("TRACER NUMBER ",I1)') jn
+         sn_tracer(jn)%clunit  = 'mmole/m3'
+         sn_tracer(jn)%llinit  = .FALSE.
+         sn_tracer(jn)%llsave  = .TRUE.
       END DO
+      ln_trcdta = .FALSE.
+
 
       REWIND( numnat )               ! read nattrc
@@ -102,9 +98,9 @@
 
       DO jn = 1, jptra
-         ctrcnm(jn) = TRIM( sn_tracer(jn)%clsname )
-         ctrcnl(jn) = TRIM( sn_tracer(jn)%cllname )
-         ctrcun(jn) = TRIM( sn_tracer(jn)%clunit  )
-         lutini(jn) =       sn_tracer(jn)%llinit 
-         lutsav(jn) =       sn_tracer(jn)%llsave
+         ctrcnm    (jn) = TRIM( sn_tracer(jn)%clsname )
+         ctrcln    (jn) = TRIM( sn_tracer(jn)%cllname )
+         ctrcun    (jn) = TRIM( sn_tracer(jn)%clunit  )
+         ln_trc_ini(jn) =       sn_tracer(jn)%llinit
+         ln_trc_wri(jn) =       sn_tracer(jn)%llsave
       END DO
 
@@ -113,57 +109,118 @@
          WRITE(numout,*)
          WRITE(numout,*) ' Namelist : namtrc'
-         WRITE(numout,*) '    time step freq. for pass. trac. nn_dttrc             = ', nn_dttrc
-         WRITE(numout,*) '    frequency of outputs for passive tracers nn_writetrc = ', nn_writetrc  
-         WRITE(numout,*) '    restart LOGICAL for passive tr. ln_rsttr             = ', ln_rsttr
-         WRITE(numout,*) '    control of time step for p. tr. nn_rsttr             = ', nn_rsttr
+         WRITE(numout,*) '   time step freq. for passive tracer           nn_dttrc      = ', nn_dttrc
+         WRITE(numout,*) '   restart  for passive tracer                  ln_rsttr      = ', ln_rsttr
+         WRITE(numout,*) '   control of time step for passive tracer      nn_rsttr      = ', nn_rsttr
+         WRITE(numout,*) '   Read inputs data from file                   ln_trcdta     = ', ln_trcdta
          WRITE(numout,*) ' '
          DO jn = 1, jptra
-            WRITE(numout,*) '   tracer nb             : ', jn 
-            WRITE(numout,*) '   short name            : ', ctrcnm(jn)
-            WRITE(numout,*) '   long name             : ', ctrcnl(jn)
-            WRITE(numout,*) '   unit                  : ', ctrcun(jn)
-            WRITE(numout,*) '   initial value in FILE : ', lutini(jn) 
-            WRITE(numout,*) ' '
+            WRITE(numout,*) '  tracer nb : ', jn, '    short name : ', ctrcnm(jn)
          END DO
+         WRITE(numout,*) ' '
       ENDIF
 
       rdttrc(:) = rdttra(:) * FLOAT( nn_dttrc )   ! vertical profile of passive tracer time-step
   
-      IF(lwp) WRITE(numout,*) 
-      IF(lwp) WRITE(numout,*) '    Passive Tracer  time step    rdttrc  = ', rdttrc(1)
-      IF(lwp) WRITE(numout,*) 
-
-#if defined key_trdmld_trc || defined key_trdtrc
-      nn_trd_trc  = 20
-      nn_ctls_trc =  9
-      rn_ucf_trc   =  1.
-      ln_trdmld_trc_instant = .TRUE.
-      ln_trdmld_trc_restart =.FALSE.
-      cn_trdrst_trc_in  = "restart_mld_trc"
-      cn_trdrst_trc_out = "restart_mld_trc"
-      ln_trdtrc(:) = .FALSE.
+      IF(lwp) THEN                   ! control print
+        WRITE(numout,*) 
+        WRITE(numout,*) '    Passive Tracer  time step    rdttrc  = ', rdttrc(1)
+        WRITE(numout,*) 
+      ENDIF
+
+      ln_diatrc = .FALSE.
+      ln_diabio = .FALSE.
+      nn_writedia = 10
+      nn_writebio = 10
 
       REWIND( numnat )               !  namelist namtoptrd : passive tracer trends diagnostic
-      READ  ( numnat, namtrc_trd )
-
-     IF(lwp) THEN
+      READ  ( numnat, namtrc_dia )
+
+      IF(lwp) THEN
          WRITE(numout,*)
-         WRITE(numout,*) ' trd_mld_trc_init : read namelist namtrc_trd                    '
-         WRITE(numout,*) ' ~~~~~~~~~~~~~~~~                                               '
-         WRITE(numout,*) '   * frequency of trends diagnostics   nn_trd_trc             = ', nn_trd_trc
-         WRITE(numout,*) '   * control surface type              nn_ctls_trc            = ', nn_ctls_trc
-         WRITE(numout,*) '   * restart for ML diagnostics        ln_trdmld_trc_restart  = ', ln_trdmld_trc_restart
-         WRITE(numout,*) '   * flag to diagnose trends of                                 '
-         WRITE(numout,*) '     instantantaneous or mean ML T/S   ln_trdmld_trc_instant  = ', ln_trdmld_trc_instant
-         WRITE(numout,*) '   * unit conversion factor            rn_ucf_trc             = ', rn_ucf_trc
-         DO jn = 1, jptra
-            IF( ln_trdtrc(jn) ) WRITE(numout,*) '    compute ML trends for tracer number :', jn
-         END DO
-      ENDIF
-#endif
+         WRITE(numout,*)
+         WRITE(numout,*) ' Namelist : namtrc_dia'
+         WRITE(numout,*) '    save additionnal diagnostics arrays         ln_diatrc   = ', ln_diatrc
+         WRITE(numout,*) '    save additionnal biology diagnostics arrays ln_diabio   = ', ln_diabio
+         WRITE(numout,*) '    frequency of outputs for additional arrays  nn_writedia = ', nn_writedia
+         WRITE(numout,*) '    frequency of outputs for biological trends  nn_writebio = ', nn_writebio
+         WRITE(numout,*) ' '
+      ENDIF
+
+      IF( ln_diatrc .AND. .NOT. lk_iomput ) THEN 
+         ALLOCATE( trc2d(jpi,jpj,jpdia2d), trc3d(jpi,jpj,jpk,jpdia3d),  &
+           &       ctrc2d(jpdia2d), ctrc2l(jpdia2d), ctrc2u(jpdia2d) ,  & 
+           &       ctrc3d(jpdia3d), ctrc3l(jpdia3d), ctrc3u(jpdia3d) ,  STAT = ierr ) 
+         IF( ierr > 0 )   CALL ctl_stop( 'STOP', 'trcnam: unable to allocate add. diag. array' )
+      ENDIF
+
+      IF( ( ln_diabio .AND. .NOT. lk_iomput ) .OR. l_trdtrc ) THEN
+         ALLOCATE( trbio (jpi,jpj,jpk,jpdiabio) , &
+           &       ctrbio(jpdiabio), ctrbil(jpdiabio), ctrbiu(jpdiabio), STAT = ierr ) 
+         IF( ierr > 0 )   CALL ctl_stop( 'STOP', 'trcnam: unable to allocate bio. diag. array' )
+      ENDIF
 
       ! namelist of transport
       ! ---------------------
       CALL trc_nam_trp
+
+
+      IF( ln_trcdmp .AND. .NOT.ln_trcdta ) THEN
+         CALL ctl_warn( 'trc_nam: passive tracer damping requires data from files we set ln_trcdta to TRUE' )
+         ln_trcdta = .TRUE.
+      ENDIF
+      !
+      IF( ln_rsttr .AND. .NOT.ln_trcdmp .AND. ln_trcdta ) THEN
+          CALL ctl_warn( 'trc_nam: passive tracer restart and  data intialisation, ',   &
+             &           'we keep the restart values and set ln_trcdta to FALSE' )
+         ln_trcdta = .FALSE.
+      ENDIF
+      !
+      IF( .NOT.ln_trcdta ) THEN
+         ln_trc_ini(:) = .FALSE.
+      ENDIF
+
+      IF(lwp) THEN                   ! control print
+         IF( ln_rsttr ) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) '    read a restart file for passive tracer : ', TRIM( cn_trcrst_in )
+            WRITE(numout,*)
+         ELSE
+            IF( .NOT.ln_trcdta ) THEN
+                WRITE(numout,*)
+                WRITE(numout,*) '  All the passive tracers are initialised with constant values '
+                WRITE(numout,*)
+            ENDIF
+         ENDIF
+      ENDIF
+
+
+#if defined key_trdmld_trc || defined key_trdtrc
+         nn_trd_trc  = 20
+         nn_ctls_trc =  9
+         rn_ucf_trc   =  1.
+         ln_trdmld_trc_instant = .TRUE.
+         ln_trdmld_trc_restart =.FALSE.
+         cn_trdrst_trc_in  = "restart_mld_trc"
+         cn_trdrst_trc_out = "restart_mld_trc"
+         ln_trdtrc(:) = .FALSE.
+
+         REWIND( numnat )               !  namelist namtoptrd : passive tracer trends diagnostic
+         READ  ( numnat, namtrc_trd )
+
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) ' trd_mld_trc_init : read namelist namtrc_trd                    '
+            WRITE(numout,*) ' ~~~~~~~~~~~~~~~~                                               '
+            WRITE(numout,*) '   * frequency of trends diagnostics   nn_trd_trc             = ', nn_trd_trc
+            WRITE(numout,*) '   * control surface type              nn_ctls_trc            = ', nn_ctls_trc
+            WRITE(numout,*) '   * restart for ML diagnostics        ln_trdmld_trc_restart  = ', ln_trdmld_trc_restart
+            WRITE(numout,*) '   * flag to diagnose trends of                                 '
+            WRITE(numout,*) '     instantantaneous or mean ML T/S   ln_trdmld_trc_instant  = ', ln_trdmld_trc_instant
+            WRITE(numout,*) '   * unit conversion factor            rn_ucf_trc             = ', rn_ucf_trc
+            DO jn = 1, jptra
+               IF( ln_trdtrc(jn) ) WRITE(numout,*) '    compute ML trends for tracer number :', jn
+            END DO
+         ENDIF
+#endif
 
 
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trcrst.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 2819)
@@ -285,6 +285,5 @@
 
       INTEGER  :: jn
-      REAL(wp) :: zdiag_var, zdiag_varmin, zdiag_varmax, zdiag_tot
-      REAL(wp) :: zder
+      REAL(wp) :: ztraf, zmin, zmax, zmean, zdrift
       !!----------------------------------------------------------------------
 
@@ -296,26 +295,20 @@
       ENDIF
       
-      zdiag_tot = 0.e0
-      DO jn = 1, jptra
-#  if defined key_degrad
-         zdiag_var = glob_sum( trn(:,:,:,jn) * cvol(:,:,:) * facvol(:,:,:) )
-#  else
-         zdiag_var = glob_sum( trn(:,:,:,jn) * cvol(:,:,:)  )
-#  endif
-         zdiag_varmin = MINVAL( trn(:,:,:,jn), mask= ((tmask*SPREAD(tmask_i,DIM=3,NCOPIES=jpk).NE.0.)) )
-         zdiag_varmax = MAXVAL( trn(:,:,:,jn), mask= ((tmask*SPREAD(tmask_i,DIM=3,NCOPIES=jpk).NE.0.)) )
+      DO jn = 1, jptra
+         IF( .NOT.lk_degrad )  THEN  ;  ztraf = glob_sum( trn(:,:,:,jn) * cvol(:,:,:) )
+         ELSE                        ;  ztraf = glob_sum( trn(:,:,:,jn) * cvol(:,:,:) * facvol(:,:,:) )
+         ENDIF
+         zmin = MINVAL( trn(:,:,:,jn), mask= ((tmask*SPREAD(tmask_i,DIM=3,NCOPIES=jpk).NE.0.)) )
+         zmax = MAXVAL( trn(:,:,:,jn), mask= ((tmask*SPREAD(tmask_i,DIM=3,NCOPIES=jpk).NE.0.)) )
          IF( lk_mpp ) THEN
-            CALL mpp_min( zdiag_varmin )      ! min over the global domain
-            CALL mpp_max( zdiag_varmax )      ! max over the global domain
+            CALL mpp_min( zmin )      ! min over the global domain
+            CALL mpp_max( zmax )      ! max over the global domain
          END IF
-         zdiag_tot = zdiag_tot + zdiag_var
-         zdiag_var = zdiag_var / areatot
-         IF(lwp) WRITE(numout,*) '   MEAN NO ', jn, ctrcnm(jn), ' = ', zdiag_var,   &
-            &                    ' MIN = ', zdiag_varmin, ' MAX = ', zdiag_varmax
-      END DO
-      
-      zder = ( ( zdiag_tot - trai ) / ( trai + 1.e-12 )  ) * 100._wp
-      IF(lwp) WRITE(numout,*) '   Integral of all tracers over the full domain  = ', zdiag_tot
-      IF(lwp) WRITE(numout,*) '   Drift of the sum of all tracers =', zder, ' %'
+         zmean  = ztraf / areatot
+         zdrift = ( ( ztraf - trai(jn) ) / ( trai(jn) + 1.e-12 )  ) * 100._wp
+         IF(lwp) WRITE(numout,*) ' tracer nb : ', jn,'   ', TRIM( ctrcnm(jn) ) , &
+            &    ' mean = ', zmean, ' min = ', zmin, ' max = ', zmax, ' drift = ', zdrift, ' %'
+      END DO
+      WRITE(numout,*) 
       
    END SUBROUTINE trc_rst_stat
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trcsms.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trcsms.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trcsms.F90	(revision 2819)
@@ -47,6 +47,4 @@
       !!---------------------------------------------------------------------
 
-      IF ( MOD( kt, nn_dttrc) /= 0 ) RETURN      ! this ROUTINE is called only every ndttrc time step
-
       IF( lk_lobster )   CALL trc_sms_lobster( kt )    ! main program of LOBSTER
       IF( lk_pisces  )   CALL trc_sms_pisces ( kt )    ! main program of PISCES 
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trcstp.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trcstp.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trcstp.F90	(revision 2819)
@@ -49,4 +49,9 @@
       !!-------------------------------------------------------------------
 
+      IF( kt == nit000 ) THEN
+                               CALL iom_close( numrtr )     ! close input  passive tracers restart file
+         IF( lk_trdmld_trc  )  CALL trd_mld_trc_init        ! trends: Mixed-layer
+      ENDIF
+      !
       IF( MOD( kt - 1 , nn_dttrc ) == 0 ) THEN      ! only every nn_dttrc time step
          !
@@ -58,13 +63,10 @@
          tra(:,:,:,:) = 0.e0
          !
-         IF( kt == nit000 .AND. lk_trdmld_trc  )  &
-            &                      CALL trd_mld_trc_init        ! trends: Mixed-layer
                                    CALL trc_rst_opn( kt )       ! Open tracer restart file 
-         IF( lk_iomput ) THEN  ;   CALL trc_wri( kt )           ! output of passive tracers
-         ELSE                  ;   CALL trc_dia( kt )
+         IF( lk_iomput ) THEN  ;   CALL trc_wri    ( kt )       ! output of passive tracers with iom I/O manager
+         ELSE                  ;   CALL trc_dia    ( kt )       ! output of passive tracers with old I/O manager
          ENDIF
-                                   CALL trc_sms( kt )           ! tracers: sink and source
-                                   CALL trc_trp( kt )           ! transport of passive tracers
-         IF( kt == nit000 )     CALL iom_close( numrtr )     ! close input  passive tracers restart file
+                                   CALL trc_sms    ( kt )       ! tracers: sources minus sinks
+                                   CALL trc_trp    ( kt )       ! transport of passive tracers
          IF( lrst_trc )            CALL trc_rst_wri( kt )       ! write tracer restart file
          IF( lk_trdmld_trc  )      CALL trd_mld_trc( kt )       ! trends: Mixed-layer
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trcwri.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trcwri.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/trcwri.F90	(revision 2819)
@@ -1,20 +1,20 @@
 MODULE trcwri
-   !!===================================================================================
+   !!======================================================================
    !!                       *** MODULE trcwri ***
    !!    TOP :   Output of passive tracers
-   !!====================================================================================
+   !!======================================================================
    !! History :   1.0  !  2009-05 (C. Ethe)  Original code
    !!----------------------------------------------------------------------
-#if defined key_top &&  defined key_iomput
+#if defined key_top && defined key_iomput
    !!----------------------------------------------------------------------
-   !!   'key_top' && 'key_iomput'                              TOP models
+   !!   'key_top'                                           TOP models
    !!----------------------------------------------------------------------
    !! trc_wri_trc   :  outputs of concentration fields
    !!----------------------------------------------------------------------
-   USE dom_oce         ! ocean space and time domain variables
-   USE oce_trc
-   USE trc
-   USE iom
-   USE dianam
+   USE dom_oce     ! ocean space and time domain variables
+   USE oce_trc     ! shared variables between ocean and passive tracers
+   USE trc         ! passive tracers common variables 
+   USE iom         ! I/O manager
+   USE dianam      ! Output file name
 
    IMPLICIT NONE
@@ -50,8 +50,8 @@
       !! ** Purpose :   output passive tracers fields 
       !!---------------------------------------------------------------------
-      INTEGER, INTENT( in ) :: kt       ! ocean time-step
-      INTEGER               :: jn
-      CHARACTER (len=20)    :: cltra
-      CHARACTER (len=40) :: clhstnam
+      INTEGER, INTENT( in )     :: kt       ! ocean time-step
+      INTEGER                   :: jn
+      CHARACTER (len=20)        :: cltra
+      CHARACTER (len=40)        :: clhstnam
       INTEGER ::   inum = 11            ! temporary logical unit
       !!---------------------------------------------------------------------
